<?php
####################################
# reference table:
#
# CREATE TABLE reference (
#  id_reference int(10) unsigned NOT NULL auto_increment,
#  id_refuser int(10) unsigned NOT NULL default '0',
#  id_referent int(10) unsigned NOT NULL default '0',
#  id_post int(10) unsigned NOT NULL default '0',
#  emotion int(10) unsigned NOT NULL default '0',
#  `comment` varchar(255) NOT NULL default '',
#  link text NOT NULL,
#  ref_time timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
#  ref_valid tinyint NOT NULL default '1',
#  id_referee int(11) default NULL,
#  PRIMARY KEY  (id_reference),
#  KEY id_refuser (id_refuser,id_referent)
# ) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='styblovy reference';
# 
# distributed under GNU/GPL licence
# stybla@2008-06-02
# zdenek.styblik@gmail.com
#####################################
class reference extends defaultLib
{
	public $settings;
	private $path = ""; // path to files;

	function __construct()
	{
		define('TIMELIMIT', 60); // limit 1 ref per X seconds
		$this->settings = new StdClass;
		$settings = $this->settings;
		$settings->config = new StdClass;
		$settings->xmlobject = new StdClass;
		$settings->layout = "layout.xsl";
		$settings->import = array();
		$settings->debug = new StdClass;
		$this->scriptname = $this->getScriptname();
		$settings->xmlobject->scriptname = $this->scriptname;
		$this->auto_index = -1;
	}
	function __destruct()
	{
		unset($settings);
	}
	public function init()
	{
		$this->path = $this->getPath();
		#$_GET['userid'] = 1; // DEBUG
		#$_COOKIE['bbuserid'] = 1; // DEBUG
		#$_COOKIE['bbpassword'] = 'fill_me_up'; // DEBUG
		require_once("{$this->path}/conf/reference_config.php");
		$dblink = mysql_connect($config['host'], $config['login'], $config['password']);
		if (!$dblink) {
			die('Nelze se pripojit: ' . mysql_error());
		}
		$db_selected = mysql_select_db($config['dbname'], $dblink);
		if (!$db_selected) {
			die ("Nelze vybrat DB {$config['dbname']}: " . mysql_error());
		}
		if (isset($_GET['action'])) {
			$action = $this->stripMe($_GET['action']);
		} else {
			$action = "default";
		}
		if (isset($_GET['postid']) && is_numeric($_GET['postid'])) {
			$_SESSION['postid'] = $this->stripMe($_GET['postid']);
		}
		try {
			switch ($action) {
				// default action - show ref for requested user
				case "showref":
					$this->showRefs($dblink);
					break;
				// adds reference for user
				case "addref":
					$this->addRef($dblink);
					break;
				// shows add-reference-form 
				case "formref":
					$this->showRefForm($dblink);
					break;
				// "hides" reference(faulty reference)
				case "modref":
					$this->modRef($dblink);
					break;
				default:
					$this->showRefs($dblink);
					break;
			}
		} catch (Exception $e) {
			$xml = $this->settings->xmlobject;
			$xml->legend = "Exception";
			$xml->text = $e->getMessage();
			$this->settings->import[0] = "xsl/message.xsl";
		}
		mysql_close($dblink);
	}
	# list references for user
	# show/hide ref for moderator
	# select user.username, forum.title from user as user, moderator as moderator, forum as forum where user.userid=moderator.userid and forum.forumid=moderator.forumid;
	# (18:03:46) stybla: aha, takze staci udelat select do tabulky moderator kde moderator.userid = $userid;
	#	(18:04:08) stybla: kdyz bude pocet radku > 0 => uzivatel je mod, jinak neni.
	private	function showRefs($dblink = null)
 	{
		if (!isset($_GET['userid']) && !is_numeric($_GET['userid'])) 
		{
			throw new Exception("UID not set");
		} else
	 	{
			$userid = $this->stripMe($_GET['userid']);
			$sql1 = "SELECT username, email FROM user WHERE userid = {$userid};";
			$result1 = mysql_query($sql1, $dblink);
			$rowcount1 = mysql_num_rows($result1);
			if ($rowcount1 != 1)
		 	{
				throw new Exception("UID not found");
			} else 
			{
				$xml = $this->settings->xmlobject;
				$sql10 = "";
				$result10 = mysql_query($sql10, $dblink);
				$rowcount10 = @mysql_num_rows($result10);
				$sql11 = "";
				$result11 = mysql_query($sql11, $dblink);
				$rowcount11 = @mysql_num_rows($result11);
				#$rowcount11 = 1; $rowcount10 = 1; // DEBUG
				if ($rowcount10 == 1 && $rowcount11 == 1)
			 	{
					// logged-in user is a mod
					$is_mod = 1;
					$xml->moderator = "yes";
					$usercond = "";
				} else
				{
					// logged-in user is not a mod or whatever
					$is_mod = 0;
					$usercond = " AND reference.ref_valid = 1";
				}
				$sql2 = "SELECT reference.id_reference, reference.id_referent, reference.emotion, reference.comment, reference.link, reference.id_referee, reference.ref_time AS ref_time, user.username AS referee, reference.ref_valid AS ref_valid FROM reference LEFT JOIN (user) ON (reference.id_referee = user.userid)
				 	WHERE id_referent = {$userid}{$usercond} ORDER BY reference.ref_time DESC;";
				$result2 = mysql_query($sql2, $dblink);
				$rowcount2 = @mysql_num_rows($result2);
				$this->settings->import[0] = "xsl/profile.xsl";
				$xml->userid = $userid;
				$row1 = mysql_fetch_assoc($result1);
				$xml->username = $row1['username'];
				if ($rowcount2 == 0)
			 	{
					$xml->norefs = "1";
				} else
			 	{
					$xml->refs = new StdClass;
					for ($a = 1; $a <= $rowcount2; $a++)
				 	{
						$row2 = mysql_fetch_assoc($result2);
						$xml->refs->entry[$a] = new StdClass;
						$xml->refs->entry[$a]->referee = $row2['referee'];
						if ($row2['emotion'] == 2)
					 	{
							# positive
							$xml->refs->entry[$a]->imgsrc = "img/positive.gif";
							$xml->refs->entry[$a]->imgalt = "pozitivní";
						} elseif ($row2['emotion'] == 0)
					 	{
							# negative
							$xml->refs->entry[$a]->imgsrc = "img/negative.gif";
							$xml->refs->entry[$a]->imgalt = "negativní";
						} elseif ($row2['emotion'] == 1)
					 	{
							# neutral
							$xml->refs->entry[$a]->imgsrc = "img/neutral.gif";
							$xml->refs->entry[$a]->imgalt = "neutralní";
						} else 
						{
							# emotion not set or error;
							# error
							$xml->refs->entry[$a]->imgsrc = "img/error.gif";
							$xml->refs->entry[$a]->imgalt = "chyba!";
						}
						$xml->refs->entry[$a]->comment = $row2['comment'];
						$xml->refs->entry[$a]->link = $this->char2ASCII($row2['link']);
						$xml->refs->entry[$a]->date = $row2['ref_time'];
						if ($is_mod == 1)
						{
							if ($row2['ref_valid'] > 0)
							{
								$xml->refs->entry[$a]->modlink = "{$this->scriptname}?action=modref&#38;refid={$row2['id_reference']}&#38;modaction=0";
								$xml->refs->entry[$a]->modlinkdesc = "vyřadit";
							} else {
								$xml->refs->entry[$a]->modlink = "{$this->scriptname}?action=modref&#38;refid={$row2['id_reference']}&#38;modaction=1";
								$xml->refs->entry[$a]->modlinkdesc = "zařadit";
							}
						}
					}
					$sql3 = "SELECT COUNT(*) AS refcount FROM reference WHERE id_referent = {$userid} AND ref_valid > 0;";
					$result3 = mysql_query($sql3, $dblink);
					$row3 = mysql_fetch_assoc($result3);
					$xml->refcount = $row3['refcount'];
					$sql4 = "SELECT COUNT(*) AS refpositive FROM reference WHERE id_referent = {$userid} AND emotion = 2 AND ref_valid > 0;";
					$result4 = mysql_query($sql4, $dblink);
					$row4 = mysql_fetch_assoc($result4);
					$xml->refpositive = $row4['refpositive'];
					$sql5 = "SELECT COUNT(*) AS refnegative FROM reference WHERE id_referent = {$userid} AND emotion = 0 AND ref_valid > 0;";
					$result5 = mysql_query($sql5, $dblink);
					$row5 = mysql_fetch_assoc($result5);
					$xml->refnegative = $row5['refnegative'];
					$sql6 = "SELECT COUNT(*) AS refneutral FROM reference WHERE id_referent = {$userid} AND emotion = 1 AND ref_valid > 0;";
					$result6 = mysql_query($sql6, $dblink);
					$row6 = mysql_fetch_assoc($result6);
					$xml->refneutral = $row6['refneutral'];
					$xml->reliability = ((int)$xml->refpositive/(int)$xml->refcount) * 100;
					$xml->reliability = round($xml->reliability, 2);
				}
			}
		}
	}

	# reference form
	# form _carry over_ pres $_
	# SESSION
	public function showRefForm($dblink = null)
 	{
		if (!is_null($dblink) && isset($_GET['userid']) && is_numeric($_GET['userid']) && isset($_COOKIE['bbuserid']) && is_numeric($_COOKIE['bbuserid']))
		{
				$userid = $this->stripMe($_GET['userid']);
				$sql1 = "SELECT username FROM user WHERE userid = {$userid}";
				$result1 = mysql_query($sql1, $dblink);
				$rowcount1 = @mysql_num_rows($result1);
				if ($rowcount1 == 1)
				{
					$xml = $this->settings->xmlobject;
					$row1 = mysql_fetch_assoc($result1);
					$xml->username = $row1['username'];
					$xml->userid = $userid;
					if (isset($_SESSION['postid']) && is_numeric($_SESSION['postid']))
				 	{
						$xml->link = "http://www.czfree.net/forum/showthread.php?postid={$_SESSION['postid']}#post{$_SESSION['postid']}";
						unset($_SESSION['postid']);
					} elseif (isset($_SESSION['ref_link']) && !empty($_SESSION['ref_link']))
				 	{
						$xml->link = $this->stripMe($_SESSION['ref_link']);
						unset($_SESSION['ref_comment']);
					}
					if (isset($_SESSION['ref_comment']) && !empty($_SESSION['ref_comment']))
				 	{
						$xml->comment = $this->stripMe($_SESSION['ref_comment']);
						unset($_SESSION['ref_comment']);
					}
					$this->settings->import[0] = "xsl/refform.xsl";
				} else
			 	{
					# error
					throw new Exception("UID not found");
				}


		} else {
			throw new Exception("špatný parametr funkce #2; userid nenalezeno; nepřihlášený uživatel; vypnuté cookies(v nastavení czf wf)?;");
		}
	}

	# add reference into db
	public function addRef($dblink = null)
 	{
		if (!is_null($dblink) && isset($_COOKIE['bbuserid']) && is_numeric($_COOKIE['bbuserid'])
		 	&& isset($_COOKIE['bbpassword']) && isset($_GET['userid']) && is_numeric($_GET['userid']))
	 	{
			if($_GET['userid'] != $_COOKIE['bbuserid'])
			{
				$xml = $this->settings->xmlobject;
				$xml->userid = $this->stripMe($_GET['userid']);
				$sql1 = "SELECT userid, email FROM user WHERE userid = {$xml->userid}";
				$result1 = mysql_query($sql1, $dblink);
				$rowcount1 = @mysql_num_rows($result1);
				if (isset($_POST['emotion']) && is_numeric($_POST['emotion'])) {
					$xml->emotion = $this->stripMe($_POST['emotion']);
				} else {
					# error
					$error = 1;
					$this->autoindex++;
					$this->errorMsg("feeback nebyl nastaven;");
				}
				if (isset($_POST['comment']))
			 	{
					$xml->comment = $this->stripMe($_POST['comment']);
					# osetreni mezer
					$xml->comment = $this->stripSpaces($xml->comment);
					if (empty($xml->comment))
					{
						$error = 1;
						$this->errorMsg("chybí komentář;");
					}
					if (strlen($xml->comment) > 255)
				 	{
						$error = 1;
						$this->errorMsg("příliš dlouhý komentář(255zn);");
					}
				} else
				{
					# error
					$error = 1;
					$this->errorMsg("chybí komentář;");
				}
				if (isset($_POST['link']) && !empty($_POST['link']))
			 	{
					$xml->link = $this->stripMe($_POST['link']);
					# osetreni mezer
					$xml->link = $this->stripSpaces($xml->link);
					# link musi zacinat VZDY http://
					# bylo by mozne pripojit ht..., ale zdalo se mi to zbytecne.
					$match = preg_match('/^http:\/\//', $xml->link);
					if ($match == 1)
				 	{
						$arr = parse_url($xml->link);
						if (isset($arr['host']) && ($arr['host'] == "www.czfree.net" || $arr['host'] == "czfree.net") && isset($arr['query'])
							&& preg_match('/postid=[0-9]+/', $arr['query'], $matches) > 0)
					 	{
							list($garbage, $postid) = @explode("=", $matches[0]);
							# existuje dany post ve foru?
							$sql2 = "SELECT user.username AS username, user.email AS email FROM post JOIN (user) ON (user.userid = post.userid)
								WHERE post.postid = {$postid} AND post.userid = {$xml->userid}";
							$result2 = mysql_query($sql2, $dblink);
							$rowcount2 = @mysql_num_rows($result2);
							# jenom pojistka
							if ($rowcount2 == 0)
						 	{
								# error
								$error = 1;
								$this->errorMsg("neexistující post;");
							}
						} else 
						{
							# error
							$error = 1;
							$this->errorMsg("špatný link(url);");
						}
					} else
					{
						# error
						$error = 1;
						$this->errorMsg("špatný link(url);");
					}
				}	else {
					# error
					$error = 1;
					$this->errorMsg("chybí link(url);");
				}
				$refereeid = $this->stripMe($_COOKIE['bbuserid']);
				$refpass = $this->stripMe($_COOKIE['bbpassword']);
				$sql20 = "SELECT username AS referee FROM user WHERE userid = {$refereeid} AND password = '{$refpass}';";
				$result20 = mysql_query($sql20, $dblink);
				$rowcount20 = @mysql_num_rows($result20);
				# reference limit 1ref/1min
				$sql21 = "SELECT MAX(UNIX_TIMESTAMP(ref_time)) AS ref_time FROM reference WHERE id_referent = {$xml->userid} AND id_referee = {$refereeid}";
				$result21 = mysql_query($sql21, $dblink);
				$rowcount21 = @mysql_num_rows($result21);
				if ($rowcount21 == 1) 
				{
					$row21 = mysql_fetch_assoc($result21);
					$now = time();
					$lastreference = $row21['ref_time'] + TIMELIMIT;
					if ($lastreference > $now) 
					{
						$error = 1;
						$this->errorMsg("počet referencí je omezený na 1 reference / " . round(TIMELIMIT/60) . " minuta;");
					}
				}
				if ($error == 0 && $rowcount1 == 1 && $rowcount2 == 1 && $rowcount20 == 1)
			 	{
					$now = time();
					$sql3 = "INSERT INTO reference (id_referent, id_referee, id_post, emotion, comment, link, ref_time, ref_valid) 
						VALUES ({$xml->userid}, {$refereeid}, {$postid}, {$xml->emotion}, '{$xml->comment}', '{$xml->link}', NOW(), 1);";
					mysql_query($sql3, $dblink);
					// notifikace e-mailem
					$subject = "www.czfree.net - reference";
					$headers = "From: \"robot - www.czfree.net\" <noreply@www.czfree.net>\nX-Mailer: PHP/" . phpversion()
					 	. "\nMIME-Version: 1.0\nContent-Type: text/html; charset=UTF-8; format=flowed;\nContent-Transfer-Encoding: 7bit;\n";
					$row20 = mysql_fetch_assoc($result20);
					$emailxmlobj = new StdClass;
					$emailxmlobj->referee = $row20['referee'];
					$emailxmlobj->link = $xml->link;
					$emailxmlobj->references = $this->getScriptname()."?userid={$xml->userid}";
					$emailxml = "<root>\n";
					$emailxml.= $this->objToXML($emailxmlobj);
					$emailxml.= "</root>\n";
					$emailxsl = $this->xslPrepare(null, "root", "xsl/email.xsl");
					$message = $this->transform($emailxml, $emailxsl);
					$row1 = mysql_fetch_assoc($result1);
					mail($row1['email'], $subject, $message, $headers);
					// end notifikace emailem
					$this->settings->import[0] = "xsl/message.xsl";
					$xml->message = "Reference byla přidána.";
					$xml->link = "{$this->scriptname}?userid={$xml->userid}";
					$xml->linkdesc = "Zpět na reference";
				} else
				{
					# error
					$this->showRefForm($dblink);
				}	
			} else {
				$xml = $this->settings->xmlobject;
				$xml->legend = "Chyba";
				$xml->text = "Nelze zanechat referenci sám sobě :)";
				$xml->link = "{$this->scriptname}?userid={$this->stripMe($_GET['userid'])}";
				$xml->linkdesc = "Zpět na reference";
				$this->settings->import[0] = "xsl/message.xsl";
			}
		} else
		{
			# error
			throw new Exception("špatný parametr funkce #3; nepřihlášený uživatel; vypnuté cookies(v nastavení czf wf)?;");
		}
	}

	private function modRef($dblink = null)
	{
		if (!is_null($dblink) && isset($_COOKIE['bbuserid']) && is_numeric($_COOKIE['bbuserid'])
			&& isset($_COOKIE['bbpassword']) && isset($_GET['userid']) && is_numeric($_GET['userid'])
			&& isset($_GET['refid']) && is_numeric($_GET['refid']))
		{
			$bbid = $this->stripMe($_COOKIE['bbuserid']);
			$bbpass = $this->stripMe($_COOKIE['bbpassword']);
			$userid = $_GET['userid'];
			$referenceid = $_GET['refid'];
			// check if log-in info in cookies is valid
			$sql1 = "SELECT username AS referee FROM user WHERE userid = {$bbid} AND password = '{$bbpass}';";
			$result1 = mysql_query($sql1, $dblink);
			$rowcount1 = @mysql_num_rows($result1);
			// check if logged-in user is in MOD table;
			$sql2 = "SELECT userid FROM moderator WHERE userid = {$bbid};";
			$result2 = mysql_query($sql2, $dblink);
			$rowcount2 = @mysql_num_rows($result2);
			#$rowcount1 = 1; $rowcount2 = 1;// DEBUG
			if ($rowcount1 == 1 && $rowcount2 == 1)
			{
				if (isset($_GET['modaction']) && is_numeric($_GET['modaction']))
				{
					if ($_GET['modaction'] > 0)
					{
						$modaction = 1;
					} else
					{
						$modaction = 0;
					}
				} else
				{
					$modaction = 0;
				}
				$sql3 = "UPDATE reference SET ref_valid = {$modaction} WHERE id_referent = {$userid} AND id_reference = {$referenceid};";
				$result3 = mysql_query($sql3, $dblink);
				$xml = $this->settings->xmlobject;
				$this->settings->import[0] = "xsl/message.xsl";
				$xml->legend = "Úprava reference";
				$xml->text = "Reference byla upravena";
				$xml->linkdesc = "Zpět na reference";
				$xml->link = "{$this->scriptname}?userid={$userid}";
			} else {
				$this->settings->import[0] = "xsl/message.xsl";
				$xml = $this->settings->xmlobject;
				$xml->legend = "Chyba";
				$xml->text = "Pokoušíte se o akci, kterou mají povolenou pouze moderátoři. To se bude muset nahlásit!";
				$xml->link = "{$this->scriptname}?userid={$userid}";
				$xml->linkdesc = "Zpět na reference";
			}
		} else
		{
			# error
			throw new Exception("špatný parametr funkce #4; nepřihlášený uživatel; vypnuté cookies(v nastavení czf wf)?;");
		}
	}

	/* support functions */
	private function errorMsg($text)
	{
		$xml = $this->settings->xmlobject;
		$this->autoindex++;
		if (!isset($xml->fault) || !is_array($xml->fault))
			$xml->fault = array();
		$xml->fault[$this->autoindex] = new StdClass;
		$xml->fault[$this->autoindex]->text = $text;
	}
	public function stripSpaces($text)
 	{
		$text = preg_replace('/^\s*$/', "", $text);
		$text = preg_replace('/\s*$/', "", $text);
		return $text;
	}

	public function char2ASCII($text)
 	{
		$char_code[2] = "#\<+#s";
		$char_code[1] = "#\>+#s";
		$char_code[0] = "#(&[^\#0-9]{1,3}?)+#s";
		$char_replacement[2] = "&#60;";
		$char_replacement[1] = "&#62;";
		$char_replacement[0] = "&amp;";
		$output = preg_replace($char_code, $char_replacement, $text, -1);
		return $output;
	}
	/* support functions */
}
?>
