<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:template name="exttemplate">
		<fieldset>
			<legend>
				Reference pro uživatele <a target="_blank" href="http://www.czfree.net/forum/member.php?s=&#38;action=getinfo&#38;userid={userid}"><xsl:value-of select="username" /></a>
			</legend>
			<xsl:if test="fault">
				<ul>
					<xsl:for-each select="fault">
						<li><xsl:value-of select="text" /></li>
					</xsl:for-each>
				</ul>
			</xsl:if>
			<form name="referenceform" method="post" action="{scriptname}?action=addref&#38;userid={userid}">
				<div style="padding: 0.2em;">
					<span class="textbold">odkaz na post ve fóru:</span><br />
					<input class="forminput" type="text" size="128" name="link" value="{link}"/>
				</div>
				<div style="padding: 0.2em; margin-top: 10px;">
					<span class="textbold">feedback:</span><br />
					<div class="forminput">
						<span class="forminputpadd">
							<input type="radio" name="emotion" value="2" /><img class="icon" src="img/positive.gif" alt="pozitivni" /> pozitivní
						</span>
						<span class="forminputpadd">
							<input type="radio" name="emotion" value="1" /><img class="icon" src="img/neutral.gif" alt="neutralni" /> neutrální
						</span>
						<span class="forminputpadd">
							<input type="radio" name="emotion" value="0" /><img class="icon" src="img/negative.gif" alt="negativni" /> negativní
						</span>
					</div>
				</div>
				<div style="padding: 0.2em; margin-top: 10px;">
					<span class="textbold">komentář:</span><br />
					<input class="forminput" maxlength="255" size="128" name="comment" value="{comment}"/>
				</div>
				<br />
				<div id="formbuttons">
					<div>
						<a href="javascript:document.referenceform.submit()">Odeslat</a>
					</div>
					<div>
						<a href="{scriptname}?userid={userid}">Zpět na reference</a>
					</div>
				</div>
			</form>
		</fieldset>
	</xsl:template>
</xsl:stylesheet>
